%define name		nut
%define version		1.4.0
%define release		1mdk
%define nutuser		ups

%define STATEPATH  	/var/state/ups
%define CGIPATH   	/var/www/cgi-bin
%define DRVPATH   	/sbin
%define CONFPATH	%{_sysconfdir}/ups

Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL

Group:		System/Configuration/Hardware
Summary:	Network UPS Tools Client Utilities
Source:		http://www.exploits.org/nut/release/1.4/%{name}-%{version}.tar.bz2
Source1:	upsd
Source2:	upsmon
URL:		http://www.exploits.org/nut

BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Prereq:		chkconfig fileutils rpm-helper >= 0.8
BuildRequires:	freetype2-devel libjpeg-devel libpng3-devel xpm-devel

%description
These programs are part of a developing project to monitor the assortment 
of UPSes that are found out there in the field. Many models have serial 
ports of some kind that allow some form of state checking. This
capability has been harnessed where possible to allow for safe shutdowns, 
live status tracking on web pages, and more.

This package includes the client utilities that are required to monitor a
UPS that the client host is powered from - either connected directly via
a serial port (in which case the main nut package needs to be installed on
this machine) or across the network (where another host on the network
monitors the UPS via serial cable and runs the main nut package to allow
clients to see the information).

%package server
Summary:	Network UPS Tools server
Group:		System/Servers
Requires:	nut = %{version}
Prereq:		rpm-helper >= 0.8

%description server
These programs are part of a developing project to monitor the assortment 
of UPSes that are found out there in the field. Many models have serial 
serial ports of some kind that allow some form of state checking. This
capability has been harnessed where possible to allow for safe shutdowns, 
live status tracking on web pages, and more.

This package is the main NUT upsd daemon and the associated per-UPS-model
drivers which talk to the UPSes.  You also need to install the base NUT
package.

%package cgi
Group:		Monitoring
Summary:	CGI utils for NUT
Requires:	libgd2
Requires:	apache
BuildRequires:	libgd2-devel, libpng-devel
Prereq:		rpm-helper >= 0.8
Conflicts:	apcupsd

%description cgi
These programs are part of a developing project to monitor the assortment 
of UPSes that are found out there in the field. Many models have serial 
serial ports of some kind that allow some form of state checking. This
capability has been harnessed where possible to allow for safe shutdowns, 
live status tracking on web pages, and more.

This package adds the web CGI programs.   These can be installed on a
separate machine to the rest of the NUT package.


%package devel
Group:		Monitoring
Summary:	Development for NUT Client
Requires:	libgd2
Requires:	apache
BuildRequires:	libgd2-devel, libpng-devel
Prereq:		rpm-helper >= 0.8

%description devel
This package contains the development header files and libraries
necessary to develop NUT client applications.


%prep
%setup -q
autoconf

%build
%serverbuild
CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--with-cgi \
	--with-statepath=%{STATEPATH} \
	--with-drvpath=%{DRVPATH} \
	--with-cgipath=%{CGIPATH} \
	--with-gd-libs \
	--with-user=%{nutuser} \
	--with-group=%{nutuser} \
	--enable-shared \
	--sysconfdir=%{CONFPATH} \
	--mandir=%{_mandir} \
	--exec-prefix=/usr \
	--prefix=/usr \
	--libdir=%{_libdir}
%make

%install
rm -rf %{buildroot}
#
# Build basic directories here - if they exist already then the
# installer doesn't try to create and chown them (the chown is
# a killer if we are building as non-root
mkdir -p %{buildroot}%{CONFPATH}
mkdir -p %{buildroot}%{STATEPATH}
mkdir -p %{buildroot}%{DRVPATH}
mkdir -p %{buildroot}%{CGIPATH}
mkdir -p %{buildroot}%{_mandir}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
make DESTDIR=%{buildroot} install
make DESTDIR=%{buildroot} install-cgi
make DESTDIR=%{buildroot} install-misc

# install SYSV init stuff
mkdir -p %{buildroot}%{_initrddir}
install %SOURCE1 %{buildroot}/%{_initrddir}
install %SOURCE2 %{buildroot}/%{_initrddir}

# move the *.sample config files to their real locations
# we don't need to worry about overwriting anything since
# they are marked as %config files within the package
for file in %{buildroot}%{CONFPATH}/*.sample
do
    mv $file %{buildroot}%{CONFPATH}/`basename $file .sample`
done

#
# Pas bon car upsmon.conf.sample s'installe  chaque fois,
# donc reconfig : a revoir
# + verifier le system d'arret
# utiliser un /etc/sysconfig/ups  la place ?
#

mv %{buildroot}%{CONFPATH}/upsmon.conf %{buildroot}%{CONFPATH}/upsmon.conf.sample
perl -pi -e 's/# RUN_AS_USER nutmon/RUN_AS_USER ups/g' %{buildroot}%{CONFPATH}/upsmon.conf.sample

%pre
# Create an UPS user.
%_pre_useradd ups %{STATEPATH} /bin/false
%_pre_groupadd ups ups
%_pre_groupadd tty ups
%_pre_groupadd usb ups
#groupadd -r ups >/dev/null 2>&1 || :
#useradd -M -r -g ups -d %{STATEPATH} -s "" -c "UPSD Daemon" -G tty,usb ups 2> /dev/null || true

%preun
# only do this if it is not an upgrade
%_preun_service upsmon

%post
%_post_service upsmon

%postun
# Only do this if it is not an upgrade
if [ ! -f %_sbindir/upsd ]; then
   %_postun_userdel ups
fi

%pre	server
# Create an UPS user. We do not use the buggy macro %_pre_groupadd anymore.
%_pre_useradd ups %{STATEPATH} /bin/false
%_pre_groupadd ups ups
%_pre_groupadd tty ups
%_pre_groupadd usb ups
#groupadd -r ups >/dev/null 2>&1 || :
#useradd -M -r -g ups -d %{STATEPATH} -s "" -c "UPSD Daemon" -G tty,usb ups 2> /dev/null || true

%preun	server
%_preun_service upsd

%post	server
%_post_service upsd

%postun	server
# Only do this if it is not an upgrade
if [ ! -f %_sbindir/upsmon ]; then
   %_postun_userdel ups
fi

%clean
rm -rf %{buildroot}

%files	server
%defattr(-,root,root)
%{DRVPATH}/*
%{_sbindir}/upsd
%config(noreplace) %attr(755,root,root) %{_initrddir}/upsd
%dir %attr(755,root,root) %{CONFPATH}
%config(noreplace) %attr(644,root,root) %{CONFPATH}/ups.conf
%config(noreplace) %attr(640,root,ups) %{CONFPATH}/upsd.users
%config(noreplace) %attr(640,root,ups) %{CONFPATH}/upsd.conf
/usr/share/cmdvartab
%{_mandir}/man5/ups.conf.5.bz2
%{_mandir}/man5/upsd.conf.5.bz2
%{_mandir}/man5/upsd.users.5.bz2
%{_mandir}/man8/apcsmart.8.bz2
%{_mandir}/man8/bcmxcp.8.bz2
%{_mandir}/man8/belkin.8.bz2
%{_mandir}/man8/bestups.8.bz2
%{_mandir}/man8/bestferrups801-807.8.bz2
%{_mandir}/man8/bestfortress.8.bz2
%{_mandir}/man8/bestuferrups.8.bz2
%{_mandir}/man8/cyberpower.8.bz2
%{_mandir}/man8/everups.8.bz2
%{_mandir}/man8/etapro.8.bz2
%{_mandir}/man8/fentonups.8.bz2
%{_mandir}/man8/genericups.8.bz2
%{_mandir}/man8/hp.8.bz2
%{_mandir}/man8/isbmex.8.bz2
%{_mandir}/man8/liebert.8.bz2
%{_mandir}/man8/masterguard.8.bz2
#%{_mandir}/man8/mge-ellipse.8.bz2
%{_mandir}/man8/mge-utalk.8.bz2
%{_mandir}/man8/microdowell.8.bz2
%{_mandir}/man8/newapc.8.bz2
%{_mandir}/man8/nutupsdrv.8.bz2
%{_mandir}/man8/oneac.8.bz2
%{_mandir}/man8/powercom.8.bz2
%{_mandir}/man8/powernet.8.bz2
%{_mandir}/man8/sec.8.bz2
%{_mandir}/man8/sms.8.bz2
%{_mandir}/man8/snmp-ups.8.bz2
%{_mandir}/man8/tripplite.8.bz2
%{_mandir}/man8/tripplitesu.8.bz2
%{_mandir}/man8/victronups.8.bz2
%{_mandir}/man8/upsd.8.bz2
%{_mandir}/man8/upsdrvctl.8.bz2
%{_mandir}/man8/mge-shut.8.bz2

%files
%defattr(-,root,root)
%doc CHANGES COPYING CREDITS INSTALL NEWS README docs
%dir %attr(755,root,root) %{CONFPATH}
%config(noreplace) %attr(755,root,root) %{_initrddir}/upsmon
%config(noreplace) %attr(640,root,ups) %{CONFPATH}/upssched.conf
%attr(640,root,ups) %{CONFPATH}/upsmon.conf.sample
%dir %attr(750,ups,ups) %{STATEPATH}
%_bindir/upsc
%_bindir/upscmd
%_bindir/upsrw
%_bindir/upslog
%_sbindir/upsmon
%_sbindir/upssched
%{_mandir}/man5/upsmon.conf.5.bz2
%{_mandir}/man5/upssched.conf.5.bz2
%{_mandir}/man8/upsc.8.bz2
%{_mandir}/man8/upscmd.8.bz2
%{_mandir}/man8/upsrw.8.bz2
%{_mandir}/man8/upslog.8.bz2
%{_mandir}/man8/upsmon.8.bz2
%{_mandir}/man8/upssched.8.bz2

%files cgi
%defattr(-,root,root)
%dir %attr(755,root,root) %{CONFPATH}
# The apache user will have to read this 3 files
%config(noreplace) %attr(644,root,root) %{CONFPATH}/hosts.conf
%config(noreplace) %attr(644,root,root) %{CONFPATH}/upsset.conf
%config(noreplace) %attr(644,root,root) %{CONFPATH}/upsstats.html
%config(noreplace) %attr(644,root,root) %{CONFPATH}/upsstats-single.html
%{CGIPATH}/upsimage.cgi
%{CGIPATH}/upsset.cgi
%{CGIPATH}/upsstats.cgi
%{_mandir}/man5/hosts.conf.5.bz2
%{_mandir}/man5/upsstats.html.5.bz2
%{_mandir}/man5/upsset.conf.5.bz2
%{_mandir}/man8/upsimage.cgi.8.bz2
%{_mandir}/man8/upsset.cgi.8.bz2
%{_mandir}/man8/upsstats.cgi.8.bz2

%files devel
%defattr(-,root,root)
%{_includedir}/*.h
%{_libdir}/*.o
%{_mandir}/man3/upscli_connect.3.bz2
%{_mandir}/man3/upscli_disconnect.3.bz2
%{_mandir}/man3/upscli_getlist.3.bz2
%{_mandir}/man3/upscli_getvar.3.bz2
%{_mandir}/man3/upscli_readline.3.bz2
%{_mandir}/man3/upscli_sendline.3.bz2
%{_mandir}/man3/upscli_splitname.3.bz2
%{_mandir}/man3/upscli_strerror.3.bz2


%changelog
* Wed Jul 30 2003 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.4.0-1mdk
- New stable tree: 1.4.0 released

* Tue Jul 29 2003 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.2.3-2mdk
- Add cgi conflict with apcupsd wich is using the same file name for its cgi

* Wed Jul 23 2003 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.2.3-1mdk
- New release
- Change gid of upssched.conf, upsd.conf & upsd.users

* Fri Jan 24 2003 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.2.1-4mdk
- Requires

* Sat Dec 28 2002 Stefan van der Eijk <stefan@eijk.nu> 1.2.1-2mdk
- BuildRequires

* Fri Dec 20 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.2.1-1mdk
- New Release

* Thu Nov 14 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.2.0-1mdk
- New Release
- Do not use the buggy macro %_pre_groupadd anymore
- Create the devel package

* Thu Aug 29 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.0.0-4mdk
- TODO

* Mon Aug 26 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.0.0-3mdk
- Change STATEPATH, change owner of upsd.* files and modify init scripts

* Mon Aug 26 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.0.0-2mdk
- Add the user ups to the group tty and usb with rpmhelper.
- Add new runlevel scripts
- Remove upspowerdown: now supported in the Mandrake halt init script.

* Wed Aug 21 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 1.0.0-1mdk
- New release
- Use rpm-helper
- Add some new manuals to %files

* Mon Jul 22 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 0.50.0-1mdk
- New release
- Add upssched-cmd in the doc directory

* Wed Feb 07 2002 Arnaud de Lorbeau <adelorbeau@mandrakesoft.com> 0.45.3-2mdk
- Specfile adaptations for Mandrake Linux.

* Wed Oct 24 2001 Peter Bieringer <pb@bieringer.de> (0.45.3pre1)
- Take man path given by rpm instead of hardwired
- Add some missing man pages to %files

* Wed Feb 07 2001 Karl O. Pinc <kop@meme.com> (0.44.3-pre2)
- Cgi package buildrequires gd >= 1.6
- Added man pages for apcsmart and powercom models

* Tue Dec 05 2000 <Nigel.Metheringham@InTechnology.co.uk> (0.44.2)
- Made cgi package standalone (needs no other parts of NUT)
- Moved some configs into cgi
- Shared hosts.conf between cgi & main

* Fri Nov 24 2000 <Nigel.Metheringham@InTechnology.co.uk> (0.44.2)
- Moved models to be more FHS compliant and make sure they are there
  if everything but root is unmounted
- Moved a few things around

* Mon Aug 21 2000 <Nigel.Metheringham@Vdata.co.uk> (0.44.1)
- Added new model drivers into rpm list
- Made it wildcard more stuff so this doesn't need to be
  maintained for every little change.
  ** NOTE this breaks things if modelpath isn't distinct **

* Mon Jul 17 2000 <Nigel.Metheringham@Vdata.co.uk> (0.44.0)
- Fixed some problems in the spec file
- Dropped the older changelog entries since there is some
  intermediate history thats been missed.
- Added new model drivers into rpm list
- Updated descriptions somewhat

